diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/taxonomy.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/taxonomy.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/taxonomy.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/taxonomy.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 47,52 ****
--- 47,53 ----
  		'rewrite' => $rewrite['category'],
  		'public' => true,
  		'show_ui' => true,
+ 		'show_admin_column' => true,
  		'_builtin' => true,
  	) );
  
***************
*** 56,61 ****
--- 57,63 ----
  		'rewrite' => $rewrite['post_tag'],
  		'public' => true,
  		'show_ui' => true,
+ 		'show_admin_column' => true,
  		'_builtin' => true,
  	) );
  
***************
*** 89,94 ****
--- 91,102 ----
  			'add_or_remove_items' => null,
  			'choose_from_most_used' => null,
  		),
+ 		'capabilities' => array(
+ 			'manage_terms' => 'manage_links',
+ 			'edit_terms'   => 'manage_links',
+ 			'delete_terms' => 'manage_links',
+ 			'assign_terms' => 'manage_links',
+ 		),
  		'query_var' => false,
  		'rewrite' => false,
  		'public' => false,
***************
*** 301,306 ****
--- 309,315 ----
   * @param string $taxonomy Name of taxonomy object
   * @param array|string $object_type Name of the object type for the taxonomy object.
   * @param array|string $args See above description for the two keys values.
+  * @return null|WP_Error WP_Error if errors, otherwise null.
   */
  function register_taxonomy( $taxonomy, $object_type, $args = array() ) {
  	global $wp_taxonomies, $wp;
***************
*** 322,331 ****
  					);
  	$args = wp_parse_args($args, $defaults);
  
  	if ( false !== $args['query_var'] && !empty($wp) ) {
  		if ( true === $args['query_var'] )
  			$args['query_var'] = $taxonomy;
! 		$args['query_var'] = sanitize_title_with_dashes($args['query_var']);
  		$wp->add_query_var($args['query_var']);
  	}
  
--- 331,344 ----
  					);
  	$args = wp_parse_args($args, $defaults);
  
+ 	if ( strlen( $taxonomy ) > 32 )
+ 		return new WP_Error( 'taxonomy_too_long', __( 'Taxonomies cannot exceed 32 characters in length' ) );
+ 
  	if ( false !== $args['query_var'] && !empty($wp) ) {
  		if ( true === $args['query_var'] )
  			$args['query_var'] = $taxonomy;
! 		else
! 			$args['query_var'] = sanitize_title_with_dashes($args['query_var']);
  		$wp->add_query_var($args['query_var']);
  	}
  
***************
*** 651,673 ****
  		$join = '';
  		$where = array();
  		$i = 0;
  
! 		foreach ( $this->queries as $query ) {
  			$this->clean_query( $query );
  
! 			if ( is_wp_error( $query ) ) {
  				return self::$no_results;
- 			}
  
  			extract( $query );
  
  			if ( 'IN' == $operator ) {
  
  				if ( empty( $terms ) ) {
! 					if ( 'OR' == $this->relation )
  						continue;
! 					else
  						return self::$no_results;
  				}
  
  				$terms = implode( ',', $terms );
--- 664,689 ----
  		$join = '';
  		$where = array();
  		$i = 0;
+ 		$count = count( $this->queries );
  
! 		foreach ( $this->queries as $index => $query ) {
  			$this->clean_query( $query );
  
! 			if ( is_wp_error( $query ) )
  				return self::$no_results;
  
  			extract( $query );
  
  			if ( 'IN' == $operator ) {
  
  				if ( empty( $terms ) ) {
! 					if ( 'OR' == $this->relation ) {
! 						if ( ( $index + 1 === $count ) && empty( $where ) )
! 							return self::$no_results;
  						continue;
! 					} else {
  						return self::$no_results;
+ 					}
  				}
  
  				$terms = implode( ',', $terms );
***************
*** 711,717 ****
  			$i++;
  		}
  
! 		if ( !empty( $where ) )
  			$where = ' AND ( ' . implode( " $this->relation ", $where ) . ' )';
  		else
  			$where = '';
--- 727,733 ----
  			$i++;
  		}
  
! 		if ( ! empty( $where ) )
  			$where = ' AND ( ' . implode( " $this->relation ", $where ) . ' )';
  		else
  			$where = '';
***************
*** 756,767 ****
  	 * Transforms a single query, from one field to another.
  	 *
  	 * @since 3.2.0
- 	 * @access private
  	 *
  	 * @param array &$query The single query
  	 * @param string $resulting_field The resulting field
  	 */
! 	private function transform_query( &$query, $resulting_field ) {
  		global $wpdb;
  
  		if ( empty( $query['terms'] ) )
--- 772,782 ----
  	 * Transforms a single query, from one field to another.
  	 *
  	 * @since 3.2.0
  	 *
  	 * @param array &$query The single query
  	 * @param string $resulting_field The resulting field
  	 */
! 	public function transform_query( &$query, $resulting_field ) {
  		global $wpdb;
  
  		if ( empty( $query['terms'] ) )
***************
*** 784,790 ****
  					AND $wpdb->terms.{$query['field']} IN ($terms)
  				" );
  				break;
! 
  			default:
  				$terms = implode( ',', array_map( 'intval', $query['terms'] ) );
  				$terms = $wpdb->get_col( "
--- 799,812 ----
  					AND $wpdb->terms.{$query['field']} IN ($terms)
  				" );
  				break;
! 			case 'term_taxonomy_id':
! 				$terms = implode( ',', array_map( 'intval', $query['terms'] ) );
! 				$terms = $wpdb->get_col( "
! 					SELECT $resulting_field
! 					FROM $wpdb->term_taxonomy
! 					WHERE term_taxonomy_id IN ($terms)
! 				" );
! 				break;
  			default:
  				$terms = implode( ',', array_map( 'intval', $query['terms'] ) );
  				$terms = $wpdb->get_col( "
***************
*** 845,851 ****
   * @return mixed|null|WP_Error Term Row from database. Will return null if $term is empty. If taxonomy does not
   * exist then WP_Error will be returned.
   */
! function &get_term($term, $taxonomy, $output = OBJECT, $filter = 'raw') {
  	global $wpdb;
  	$null = null;
  
--- 867,873 ----
   * @return mixed|null|WP_Error Term Row from database. Will return null if $term is empty. If taxonomy does not
   * exist then WP_Error will be returned.
   */
! function get_term($term, $taxonomy, $output = OBJECT, $filter = 'raw') {
  	global $wpdb;
  	$null = null;
  
***************
*** 1162,1176 ****
   * @param string|array $args The values of what to search for when returning terms
   * @return array|WP_Error List of Term Objects and their children. Will return WP_Error, if any of $taxonomies do not exist.
   */
! function &get_terms($taxonomies, $args = '') {
  	global $wpdb;
  	$empty_array = array();
  
! 	$single_taxonomy = false;
! 	if ( !is_array($taxonomies) ) {
! 		$single_taxonomy = true;
! 		$taxonomies = array($taxonomies);
! 	}
  
  	foreach ( $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists($taxonomy) ) {
--- 1184,1196 ----
   * @param string|array $args The values of what to search for when returning terms
   * @return array|WP_Error List of Term Objects and their children. Will return WP_Error, if any of $taxonomies do not exist.
   */
! function get_terms($taxonomies, $args = '') {
  	global $wpdb;
  	$empty_array = array();
  
! 	$single_taxonomy = ! is_array( $taxonomies ) || 1 === count( $taxonomies );
! 	if ( ! is_array( $taxonomies ) )
! 		$taxonomies = array( $taxonomies );
  
  	foreach ( $taxonomies as $taxonomy ) {
  		if ( ! taxonomy_exists($taxonomy) ) {
***************
*** 1384,1390 ****
  	}
  
  	if ( empty($terms) ) {
! 		wp_cache_add( $cache_key, array(), 'terms', 86400 ); // one day
  		$terms = apply_filters('get_terms', array(), $taxonomies, $args);
  		return $terms;
  	}
--- 1404,1410 ----
  	}
  
  	if ( empty($terms) ) {
! 		wp_cache_add( $cache_key, array(), 'terms', DAY_IN_SECONDS );
  		$terms = apply_filters('get_terms', array(), $taxonomies, $args);
  		return $terms;
  	}
***************
*** 1392,1398 ****
  	if ( $child_of ) {
  		$children = _get_term_hierarchy($taxonomies[0]);
  		if ( ! empty($children) )
! 			$terms = & _get_term_children($child_of, $terms, $taxonomies[0]);
  	}
  
  	// Update term counts to include children.
--- 1412,1418 ----
  	if ( $child_of ) {
  		$children = _get_term_hierarchy($taxonomies[0]);
  		if ( ! empty($children) )
! 			$terms = _get_term_children($child_of, $terms, $taxonomies[0]);
  	}
  
  	// Update term counts to include children.
***************
*** 1435,1441 ****
  		$terms = array_slice($terms, $offset, $number);
  	}
  
! 	wp_cache_add( $cache_key, $terms, 'terms', 86400 ); // one day
  
  	$terms = apply_filters('get_terms', $terms, $taxonomies, $args);
  	return $terms;
--- 1455,1461 ----
  		$terms = array_slice($terms, $offset, $number);
  	}
  
! 	wp_cache_add( $cache_key, $terms, 'terms', DAY_IN_SECONDS );
  
  	$terms = apply_filters('get_terms', $terms, $taxonomies, $args);
  	return $terms;
***************
*** 1665,1671 ****
   *
   * @param string $taxonomy Taxonomy name
   * @param array|string $args Overwrite defaults. See get_terms()
!  * @return int How many terms are in $taxonomy
   */
  function wp_count_terms( $taxonomy, $args = array() ) {
  	$defaults = array('hide_empty' => false);
--- 1685,1691 ----
   *
   * @param string $taxonomy Taxonomy name
   * @param array|string $args Overwrite defaults. See get_terms()
!  * @return int|WP_Error How many terms are in $taxonomy. WP_Error if $taxonomy does not exist.
   */
  function wp_count_terms( $taxonomy, $args = array() ) {
  	$defaults = array('hide_empty' => false);
***************
*** 1802,1807 ****
--- 1822,1830 ----
  	foreach ( $tax_object->object_type as $object_type )
  		clean_object_term_cache( $objects, $object_type );
  
+ 	// Get the object before deletion so we can pass to actions below
+ 	$deleted_term = get_term( $term, $taxonomy );
+ 
  	do_action( 'delete_term_taxonomy', $tt_id );
  	$wpdb->delete( $wpdb->term_taxonomy, array( 'term_taxonomy_id' => $tt_id ) );
  	do_action( 'deleted_term_taxonomy', $tt_id );
***************
*** 1812,1819 ****
  
  	clean_term_cache($term, $taxonomy);
  
! 	do_action('delete_term', $term, $tt_id, $taxonomy);
! 	do_action("delete_$taxonomy", $term, $tt_id);
  
  	return true;
  }
--- 1835,1842 ----
  
  	clean_term_cache($term, $taxonomy);
  
! 	do_action( 'delete_term', $term, $tt_id, $taxonomy, $deleted_term );
! 	do_action( "delete_$taxonomy", $term, $tt_id, $deleted_term );
  
  	return true;
  }
***************
*** 2211,2219 ****
  			if ( in_array($tt_id, $final_tt_ids) )
  				$values[] = $wpdb->prepare( "(%d, %d, %d)", $object_id, $tt_id, ++$term_order);
  		if ( $values )
! 			$wpdb->query("INSERT INTO $wpdb->term_relationships (object_id, term_taxonomy_id, term_order) VALUES " . join(',', $values) . " ON DUPLICATE KEY UPDATE term_order = VALUES(term_order)");
  	}
  
  	do_action('set_object_terms', $object_id, $terms, $tt_ids, $taxonomy, $append, $old_tt_ids);
  	return $tt_ids;
  }
--- 2234,2245 ----
  			if ( in_array($tt_id, $final_tt_ids) )
  				$values[] = $wpdb->prepare( "(%d, %d, %d)", $object_id, $tt_id, ++$term_order);
  		if ( $values )
! 			if ( false === $wpdb->query( "INSERT INTO $wpdb->term_relationships (object_id, term_taxonomy_id, term_order) VALUES " . join( ',', $values ) . " ON DUPLICATE KEY UPDATE term_order = VALUES(term_order)" ) )
! 				return new WP_Error( 'db_insert_error', __( 'Could not insert term relationship into the database' ), $wpdb->last_error );
  	}
  
+ 	wp_cache_delete( $object_id, $taxonomy . '_relationships' );
+ 
  	do_action('set_object_terms', $object_id, $terms, $tt_ids, $taxonomy, $append, $old_tt_ids);
  	return $tt_ids;
  }
***************
*** 2540,2547 ****
  	if ( !is_array($object_ids) )
  		$object_ids = array($object_ids);
  
  	foreach ( $object_ids as $id )
! 		foreach ( get_object_taxonomies($object_type) as $taxonomy )
  			wp_cache_delete($id, "{$taxonomy}_relationships");
  
  	do_action('clean_object_term_cache', $object_ids, $object_type);
--- 2566,2575 ----
  	if ( !is_array($object_ids) )
  		$object_ids = array($object_ids);
  
+ 	$taxonomies = get_object_taxonomies( $object_type );
+ 
  	foreach ( $object_ids as $id )
! 		foreach ( $taxonomies as $taxonomy )
  			wp_cache_delete($id, "{$taxonomy}_relationships");
  
  	do_action('clean_object_term_cache', $object_ids, $object_type);
***************
*** 2620,2626 ****
   * @param string $taxonomy Taxonomy Name
   * @return bool|array Empty array if $terms found, but not $taxonomy. False if nothing is in cache for $taxonomy and $id.
   */
! function &get_object_term_cache($id, $taxonomy) {
  	$cache = wp_cache_get($id, "{$taxonomy}_relationships");
  	return $cache;
  }
--- 2648,2654 ----
   * @param string $taxonomy Taxonomy Name
   * @return bool|array Empty array if $terms found, but not $taxonomy. False if nothing is in cache for $taxonomy and $id.
   */
! function get_object_term_cache($id, $taxonomy) {
  	$cache = wp_cache_get($id, "{$taxonomy}_relationships");
  	return $cache;
  }
***************
*** 2766,2772 ****
   * @param string $taxonomy The taxonomy which determines the hierarchy of the terms.
   * @return array The subset of $terms that are descendants of $term_id.
   */
! function &_get_term_children($term_id, $terms, $taxonomy) {
  	$empty_array = array();
  	if ( empty($terms) )
  		return $empty_array;
--- 2794,2800 ----
   * @param string $taxonomy The taxonomy which determines the hierarchy of the terms.
   * @return array The subset of $terms that are descendants of $term_id.
   */
! function _get_term_children($term_id, $terms, $taxonomy) {
  	$empty_array = array();
  	if ( empty($terms) )
  		return $empty_array;
***************
*** 2964,2972 ****
  
  	if ( !is_object($term) ) {
  		if ( is_int($term) ) {
! 			$term = &get_term($term, $taxonomy);
  		} else {
! 			$term = &get_term_by('slug', $term, $taxonomy);
  		}
  	}
  
--- 2992,3000 ----
  
  	if ( !is_object($term) ) {
  		if ( is_int($term) ) {
! 			$term = get_term($term, $taxonomy);
  		} else {
! 			$term = get_term_by('slug', $term, $taxonomy);
  		}
  	}
  
***************
*** 3063,3072 ****
   * @return array
   */
  function get_the_taxonomies($post = 0, $args = array() ) {
! 	if ( is_int($post) )
! 		$post =& get_post($post);
! 	elseif ( !is_object($post) )
! 		$post =& $GLOBALS['post'];
  
  	$args = wp_parse_args( $args, array(
  		'template' => '%s: %l.',
--- 3091,3097 ----
   * @return array
   */
  function get_the_taxonomies($post = 0, $args = array() ) {
! 	$post = get_post( $post );
  
  	$args = wp_parse_args( $args, array(
  		'template' => '%s: %l.',
***************
*** 3088,3094 ****
  			$t['template'] = $template;
  
  		$terms = get_object_term_cache($post->ID, $taxonomy);
! 		if ( empty($terms) )
  			$terms = wp_get_object_terms($post->ID, $taxonomy, $t['args']);
  
  		$links = array();
--- 3113,3119 ----
  			$t['template'] = $template;
  
  		$terms = get_object_term_cache($post->ID, $taxonomy);
! 		if ( false === $terms )
  			$terms = wp_get_object_terms($post->ID, $taxonomy, $t['args']);
  
  		$links = array();
***************
*** 3112,3118 ****
   * @return array
   */
  function get_post_taxonomies($post = 0) {
! 	$post =& get_post($post);
  
  	return get_object_taxonomies($post);
  }
--- 3137,3143 ----
   * @return array
   */
  function get_post_taxonomies($post = 0) {
! 	$post = get_post( $post );
  
  	return get_object_taxonomies($post);
  }
***************
*** 3138,3144 ****
  		return new WP_Error( 'invalid_object', __( 'Invalid object ID' ) );
  
  	$object_terms = get_object_term_cache( $object_id, $taxonomy );
! 	if ( empty( $object_terms ) )
  		 $object_terms = wp_get_object_terms( $object_id, $taxonomy );
  
  	if ( is_wp_error( $object_terms ) )
--- 3163,3169 ----
  		return new WP_Error( 'invalid_object', __( 'Invalid object ID' ) );
  
  	$object_terms = get_object_term_cache( $object_id, $taxonomy );
! 	if ( false === $object_terms )
  		 $object_terms = wp_get_object_terms( $object_id, $taxonomy );
  
  	if ( is_wp_error( $object_terms ) )
***************
*** 3211,3226 ****
  			$ancestors[] = (int) $term->parent;
  			$term = get_term($term->parent, $object_type);
  		}
! 	} elseif ( null !== get_post_type_object( $object_type ) ) {
! 		$object = get_post($object_id);
! 		if ( ! is_wp_error( $object ) && isset( $object->ancestors ) && is_array( $object->ancestors ) )
! 			$ancestors = $object->ancestors;
! 		else {
! 			while ( ! is_wp_error($object) && ! empty( $object->post_parent ) && ! in_array( $object->post_parent, $ancestors ) ) {
! 				$ancestors[] = (int) $object->post_parent;
! 				$object = get_post($object->post_parent);
! 			}
! 		}
  	}
  
  	return apply_filters('get_ancestors', $ancestors, $object_id, $object_type);
--- 3236,3243 ----
  			$ancestors[] = (int) $term->parent;
  			$term = get_term($term->parent, $object_type);
  		}
! 	} elseif ( post_type_exists( $object_type ) ) {
! 		$ancestors = get_post_ancestors($object_id);
  	}
  
  	return apply_filters('get_ancestors', $ancestors, $object_id, $object_type);
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/template-loader.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/template-loader.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/template-loader.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/template-loader.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 6,11 ****
--- 6,15 ----
  if ( defined('WP_USE_THEMES') && WP_USE_THEMES )
  	do_action('template_redirect');
  
+ // Halt template load for HEAD requests. Performance bump. See #14348
+ if ( 'HEAD' === $_SERVER['REQUEST_METHOD'] && apply_filters( 'exit_on_http_head', true ) )
+ 	exit();
+ 
  // Process feeds and trackbacks even if not using themes.
  if ( is_robots() ) :
  	do_action('do_robots');
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/template.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/template.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 59,69 ****
   * @return string
   */
  function get_archive_template() {
! 	$post_type = get_query_var( 'post_type' );
  
  	$templates = array();
  
! 	if ( $post_type )
  		$templates[] = "archive-{$post_type}.php";
  	$templates[] = 'archive.php';
  
--- 59,69 ----
   * @return string
   */
  function get_archive_template() {
! 	$post_types = get_query_var( 'post_type' );
  
  	$templates = array();
  
! 	foreach ( (array) $post_types as $post_type )
  		$templates[] = "archive-{$post_type}.php";
  	$templates[] = 'archive.php';
  
***************
*** 82,89 ****
  
  	$templates = array();
  
! 	$templates[] = "author-{$author->user_nicename}.php";
! 	$templates[] = "author-{$author->ID}.php";
  	$templates[] = 'author.php';
  
  	return get_query_template( 'author', $templates );
--- 82,91 ----
  
  	$templates = array();
  
! 	if ( $author ) {
! 		$templates[] = "author-{$author->user_nicename}.php";
! 		$templates[] = "author-{$author->ID}.php";
! 	}
  	$templates[] = 'author.php';
  
  	return get_query_template( 'author', $templates );
***************
*** 106,113 ****
  
  	$templates = array();
  
! 	$templates[] = "category-{$category->slug}.php";
! 	$templates[] = "category-{$category->term_id}.php";
  	$templates[] = 'category.php';
  
  	return get_query_template( 'category', $templates );
--- 108,117 ----
  
  	$templates = array();
  
! 	if ( $category ) {
! 		$templates[] = "category-{$category->slug}.php";
! 		$templates[] = "category-{$category->term_id}.php";
! 	}
  	$templates[] = 'category.php';
  
  	return get_query_template( 'category', $templates );
***************
*** 130,137 ****
  
  	$templates = array();
  
! 	$templates[] = "tag-{$tag->slug}.php";
! 	$templates[] = "tag-{$tag->term_id}.php";
  	$templates[] = 'tag.php';
  
  	return get_query_template( 'tag', $templates );
--- 134,143 ----
  
  	$templates = array();
  
! 	if ( $tag ) {
! 		$templates[] = "tag-{$tag->slug}.php";
! 		$templates[] = "tag-{$tag->term_id}.php";
! 	}
  	$templates[] = 'tag.php';
  
  	return get_query_template( 'tag', $templates );
***************
*** 156,167 ****
   */
  function get_taxonomy_template() {
  	$term = get_queried_object();
- 	$taxonomy = $term->taxonomy;
  
  	$templates = array();
  
! 	$templates[] = "taxonomy-$taxonomy-{$term->slug}.php";
! 	$templates[] = "taxonomy-$taxonomy.php";
  	$templates[] = 'taxonomy.php';
  
  	return get_query_template( 'taxonomy', $templates );
--- 162,175 ----
   */
  function get_taxonomy_template() {
  	$term = get_queried_object();
  
  	$templates = array();
  
! 	if ( $term ) {
! 		$taxonomy = $term->taxonomy;
! 		$templates[] = "taxonomy-$taxonomy-{$term->slug}.php";
! 		$templates[] = "taxonomy-$taxonomy.php";
! 	}
  	$templates[] = 'taxonomy.php';
  
  	return get_query_template( 'taxonomy', $templates );
***************
*** 280,286 ****
  
  	$templates = array();
  
! 	$templates[] = "single-{$object->post_type}.php";
  	$templates[] = "single.php";
  
  	return get_query_template( 'single', $templates );
--- 288,295 ----
  
  	$templates = array();
  
! 	if ( $object )
! 		$templates[] = "single-{$object->post_type}.php";
  	$templates[] = "single.php";
  
  	return get_query_template( 'single', $templates );
***************
*** 303,317 ****
   */
  function get_attachment_template() {
  	global $posts;
! 	$type = explode('/', $posts[0]->post_mime_type);
! 	if ( $template = get_query_template($type[0]) )
! 		return $template;
! 	elseif ( $template = get_query_template($type[1]) )
! 		return $template;
! 	elseif ( $template = get_query_template("$type[0]_$type[1]") )
! 		return $template;
! 	else
! 		return get_query_template('attachment');
  }
  
  /**
--- 312,332 ----
   */
  function get_attachment_template() {
  	global $posts;
! 
! 	if ( ! empty( $posts ) && isset( $posts[0]->post_mime_type ) ) {
! 		$type = explode( '/', $posts[0]->post_mime_type );
! 
! 		if ( ! empty( $type ) ) {
! 			if ( $template = get_query_template( $type[0] ) )
! 				return $template;
! 			elseif ( $template = get_query_template( $type[1] ) )
! 				return $template;
! 			elseif ( $template = get_query_template( "$type[0]_$type[1]" ) )
! 				return $template;
! 		}
! 	}
! 
! 	return get_query_template( 'attachment' );
  }
  
  /**
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/theme-compat/comments.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/theme-compat/comments.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/theme-compat/comments.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/theme-compat/comments.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 69,75 ****
  
  <?php if ( is_user_logged_in() ) : ?>
  
! <p><?php printf(__('Logged in as <a href="%1$s">%2$s</a>.'), get_option('siteurl') . '/wp-admin/profile.php', $user_identity); ?> <a href="<?php echo wp_logout_url(get_permalink()); ?>" title="<?php esc_attr_e('Log out of this account'); ?>"><?php _e('Log out &raquo;'); ?></a></p>
  
  <?php else : ?>
  
--- 69,75 ----
  
  <?php if ( is_user_logged_in() ) : ?>
  
! <p><?php printf(__('Logged in as <a href="%1$s">%2$s</a>.'), get_edit_user_link(), $user_identity); ?> <a href="<?php echo wp_logout_url(get_permalink()); ?>" title="<?php esc_attr_e('Log out of this account'); ?>"><?php _e('Log out &raquo;'); ?></a></p>
  
  <?php else : ?>
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/theme-compat/comments-popup.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/theme-compat/comments-popup.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/theme-compat/comments-popup.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/theme-compat/comments-popup.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 32,38 ****
  ?>
  <h2 id="comments"><?php _e('Comments'); ?></h2>
  
! <p><a href="<?php echo get_post_comments_feed_link($post->ID); ?>"><?php _e('<abbr title="Really Simple Syndication">RSS</abbr> feed for comments on this post.'); ?></a></p>
  
  <?php if ( pings_open() ) { ?>
  <p><?php printf(__('The <abbr title="Universal Resource Locator">URL</abbr> to TrackBack this entry is: <em>%s</em>'), get_trackback_url()); ?></p>
--- 32,38 ----
  ?>
  <h2 id="comments"><?php _e('Comments'); ?></h2>
  
! <p><a href="<?php echo esc_url( get_post_comments_feed_link($post->ID) ); ?>"><?php _e('<abbr title="Really Simple Syndication">RSS</abbr> feed for comments on this post.'); ?></a></p>
  
  <?php if ( pings_open() ) { ?>
  <p><?php printf(__('The <abbr title="Universal Resource Locator">URL</abbr> to TrackBack this entry is: <em>%s</em>'), get_trackback_url()); ?></p>
***************
*** 68,74 ****
  
  <form action="<?php echo get_option('siteurl'); ?>/wp-comments-post.php" method="post" id="commentform">
  <?php if ( $user_ID ) : ?>
! 	<p><?php printf(__('Logged in as <a href="%1$s">%2$s</a>. <a href="%3$s" title="Log out of this account">Log out &raquo;</a>'), get_option('siteurl') . '/wp-admin/profile.php', $user_identity, wp_logout_url(get_permalink())); ?></p>
  <?php else : ?>
  	<p>
  	  <input type="text" name="author" id="author" class="textarea" value="<?php echo esc_attr($comment_author); ?>" size="28" tabindex="1" />
--- 68,74 ----
  
  <form action="<?php echo get_option('siteurl'); ?>/wp-comments-post.php" method="post" id="commentform">
  <?php if ( $user_ID ) : ?>
! 	<p><?php printf(__('Logged in as <a href="%1$s">%2$s</a>. <a href="%3$s" title="Log out of this account">Log out &raquo;</a>'), get_edit_user_link(), $user_identity, wp_logout_url(get_permalink())); ?></p>
  <?php else : ?>
  	<p>
  	  <input type="text" name="author" id="author" class="textarea" value="<?php echo esc_attr($comment_author); ?>" size="28" tabindex="1" />
